#ifndef MAIN_H
#define MAIN_H

/**** INCLUDES ****/
#include "Arduino.h"
#include "seriallogger.h"
#include "temperature.h"
#include "rswitch.h"
#include <RCSwitch.h>

/**** DEFINES ****/
#define UPDATEDELAY 10
#define TEMPPIN 0 // analog
#define SWITCHPIN 4 // digital

/**** VARIABLES ****/
Seriallogger *logger;
TemperatureThermistor *tempsensor;
RSwitch *rswitch; 


void setup() {
logger = new Seriallogger();
tempsensor = new TemperatureThermistor(TEMPPIN);  
rswitch = new RSwitch("01111","01000",SWITCHPIN);
}

void loop() {

  if (Serial.available()) {
    int key = Serial.parseInt();
    
    switch(key){
      case 0: // serial begin request, ignore
        break;
      case 1:
        logger->sendHello();
        break;
      case 2:
        logger->sendTemperature(tempsensor->getTemperature());
        break;
      case 3:
        rswitch->on();
        break;
      case 4:
        rswitch->off();
        break;
      default:
        logger->send("Unknown request");
    }
      
  }
  logger->sendTemperature(tempsensor->getTemperature());
  delay(UPDATEDELAY);
}
#endif
